# source http://12244.wpc.azureedge.net/8012244/drivers/rtdrivers/cn/nic/0010-r8168-8.045.08.tar.bz2

%global		module r8168
 
Name:		dkms-%{module}
Version:	8.045.08
Release:	%mkrel 4
Source0:	%{module}-%{version}.tar.xz
Source1:	linux-40.patch
Source2:	linux-47.patch
Source3:	linux-48.patch
# from aur
Source4:	linux-4.11.patch
# from me
Source5:	linux-4.12.patch
Source6:	linux-4.13.patch
Source7:	linux-4.15.patch
License:	GPLv2
Group:		System/Kernel and hardware
URL:		http://www.realtek.com.tw/
Summary:	dkms package for %{module} driver
Requires(post,preun): dkms
BuildRoot:	%defaultbuildroot
BuildArch:	noarch

Obsoletes:	%{name} <= %{version}

%description
This package provides the r8168 kernel module(s) for Realtek RTL8168/RTL8111,
RTL8168B/RTL8111B, RTL8168C/RTL8111C, RTL8168D/RTL8111D, RTL8168E/RTL8111E and RTL8168F/RTL8111F
Gigabit Ethernet NICs built for the Linux kernel using the x86_64 family of processors.

%prep
%setup -qn %{module}-%{version}
find -type f -exec chmod 0644 {} \;

%install
%__rm -rf %{buildroot}
%__mkdir -p %{buildroot}%{_usrsrc}/%{module}-%{version}-%{release}
###%__install -Dm644 %{S:1} %{buildroot}%{_usrsrc}/%{module}-%{version}-%{release}/patches/linux-40.patch
###%__install -Dm644 %{S:2} %{buildroot}%{_usrsrc}/%{module}-%{version}-%{release}/patches/linux-47.patch
###%__install -Dm644 %{S:3} %{buildroot}%{_usrsrc}/%{module}-%{version}-%{release}/patches/linux-48.patch
%__install -Dm644 %{S:4} %{buildroot}%{_usrsrc}/%{module}-%{version}-%{release}/patches/linux-4.11.patch
%__install -Dm644 %{S:5} %{buildroot}%{_usrsrc}/%{module}-%{version}-%{release}/patches/linux-4.12.patch
%__install -Dm644 %{S:6} %{buildroot}%{_usrsrc}/%{module}-%{version}-%{release}/patches/linux-4.13.patch
%__install -Dm644 %{S:7} %{buildroot}%{_usrsrc}/%{module}-%{version}-%{release}/patches/linux-4.15.patch
%__cp -a ./{autorun.sh,Makefile,src} %{buildroot}%{_usrsrc}/%{module}-%{version}-%{release}

cat <<EOF > %{buildroot}%{_usrsrc}/%{module}-%{version}-%{release}/dkms.conf
PACKAGE_NAME="%{module}"
PACKAGE_VERSION="%{version}-%{release}"
BUILT_MODULE_NAME[0]="\$PACKAGE_NAME"
BUILT_MODULE_LOCATION[0]="src/"
DEST_MODULE_LOCATION[0]="/kernel/drivers/net/ethernet/realtek"
PATCH[0]="linux-4.15.patch"
PATCH_MATCH[0]="4\.15\.[0-9]"
MAKE[0]="'make' clean KSRC=$kernel_source_dir EXTRA_CFLAGS='-DCONFIG_R8168_NAPI -DCONFIG_R8168_VLAN' modules"
AUTOINSTALL="yes"
CLEAN="make clean"
EOF

# to add before make
##PATCH[0]="linux-40.patch"
##PATCH_MATCH[0]="4\.0\.[1-9]"
##PATCH[1]="linux-47.patch"
##PATCH_MATCH[1]="4\.7\.[2-9]"
##PATCH[2]="linux-48.patch"
##PATCH_MATCH[2]="4\.8\.[1-9]"
##PATCH[3]="linux-4.11.patch"
##PATCH_MATCH[3]="4\.11\.[1-9]"

# keep to rewrite
# MAKE[0]="'make' clean KSRC=$kernel_source_dir EXTRA_CFLAGS='-DCONFIG_R8168_NAPI -DCONFIG_R8168_VLAN' modules"

# from 8.045.8 on not need
##PATCH[0]="linux-4.11.patch"
##PATCH[1]="linux-4.12.patch"
##PATCH[2]="linux-4.13.patch"
##PATCH_MATCH[0]="4\.11\.[1-9]"
##PATCH_MATCH[1]="4\.12\.[1-9]"
##PATCH_MATCH[2]="4\.13\.[1-9]"

%clean
%__rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc README
%{_usrsrc}/%{module}-%{version}-%{release}

%post -n dkms-%{module}
#/sbin/rmmod r8168 > /dev/null 2>&1

/usr/sbin/dkms --rpm_safe_upgrade add -m %{module} -v %{version}-%{release}
/usr/sbin/dkms --rpm_safe_upgrade build -m %{module} -v %{version}-%{release}
/usr/sbin/dkms --rpm_safe_upgrade install -m %{module} -v %{version}-%{release}

if [ "$1" = 1 ]; then
/sbin/rmmod r8169 > /dev/null 2>&1
/sbin/modprobe r8168 > /dev/null 2>&1
/sbin/service network reload > /dev/null 2>&1
echo "Reloading network configuration ... "
echo "blacklist r8169" >> /etc/modprobe.d/blacklist
echo "r8168" >> /etc/modprobe.preload
echo -e \
'\n> The module r8168 conflicts with r8169. Module r8169 has just been blacklisted by adding it to
> /etc/modprobe.d/blacklist file. Module r8168 will be loaded automatically at boot time from next boot.
> Deinstallation of dkms-r8168 package will revert changes to a previous state.\n'
fi

%preun -n dkms-%{module}
/usr/sbin/dkms --rpm_safe_upgrade remove -m %{module} -v %{version}-%{release} --all

if [ "$1" = 0 ]; then
/sbin/rmmod r8168 > /dev/null 2>&1
/sbin/modprobe r8169 > /dev/null 2>&1
/sbin/service network reload > /dev/null 2>&1
echo "Reloading network configuration ... "
sed -i '/r8169/ d' /etc/modprobe.d/blacklist
sed -i '/r8168/ d' /etc/modprobe.preload
fi

%changelog
* Tue Feb 06 2018 onkelho <oh.quait at gmail.com> 8.045.08-4pclos2018
- rebuild
- add patch for linux4.15 from aur

* Sat Oct 28 2017 onkelho <oh.quait at gmail.com> 8.045.08-2pclos2017
- rebuild

* Thu Sep 21 2017 onkelho <oh.quait at gmail.com> 8.045.08-1pclos2017
- new release from september 15 2017
- the patch-4.11 -> 4.13 now included in source

* Fri Sep 15 2017 onkelho <oh.quait at gmail.com> 8.044.02-6pclos2017
- rebuild on 4.13.2 -add patch-4.13.xx

* Tue Jul 18 2017 onkelho <oh.quait at gmail.com> 8.044.02-5pclos2017
- rebuild on 4.12.2 - test add source5 - linux-4.12.patch

* Fri May 19 2017 onkelho <oh.quait at gmail.com> 8.044.02-4pclos2017
- rebuild on 4.11.1 - buld-module-name
 
* Fri Mar 24 2017 onkelho <oh.quait at gmail.com> 8.044.02-3pclos2017
- rebuild finetune in %post

* Fri Mar 24 2017 onkelho <oh.quait at gmail.com> 8.044.02-1pclos2017
- update from 2017/02/13 0009-r8168-8.044.02.tar.bz2
- build on 4.10.5

* Tue Jan 10 2017 onkelho <oh.quait at gmail.com> 8.043.02-7pclos2017
- update from 2016/12/19 0008-r8168-8.043.02.tar.bz2
- build on 4.9.2

* Thu Dec 01 2016 onkelho <oh.quait at gmail.com> 8.043.02-6pclos2016
- don't remake initrd

* Sun Nov 27 2016 onkelho <oh.quait at gmail.com> 8.043.02-5pclos2016
- fix instlocation and conflict old 8168-8.042.xx

* Sat Nov 26 2016 onkelho <oh.quait at t-online.de>  8.043.02-4pclos2016
- update .02 - 0007-r8168-8.043.02
- add ko.xz compression

* Fri Nov 25 2016 onkelho <oh.quait at t-online.de>  8.043.02-2pclos2016
- update .02 - 0007-r8168-8.043.02

* Thu Oct 12 2016 onkelho <oh.quait at t-online.de>  8.043.01-1pclos2016
- new version from realtek

* Mon Oct 10 2016 onkelho <oh.quait at t-online.de>  8.042.00-5pclos2016
- test rebuild on linux4.8.1
- rel4 add patch48
- rel5 %__install -Dm644 %{S:3}....

* Sun Aug 28 2016 marcin82 <marcin82 at vp.pl> 8.042.00-2pclos2016
- rebuilt and patched for kernel-4.7.2

* Sun May 22 2016 marcin82 <marcin82 at vp.pl> 8.042.00-1pclos2016
- update
- changes in spec file

* Fri Dec 15 2015 marcin82 <fixxer1982@gmail.com> 8.041.00-2pclos2015
- amendment in dkms.conf file

* Fri Dec 11 2015 marcin82 <fixxer1982@gmail.com> 8.041.00-1pclos2015
- updated to new version, improvements in spec file

* Fri Jul 24 2015 marcin82 <fixxer1982@gmail.com> 8.040.00-2pclos2015
- updated dkms.conf for all 4.0.[1-9] kernels

* Mon Jun 22 2015 marcin82 <fixxer1982@gmail.com> 8.040.00-1pclos2015
- updated, improvements in spec file

* Sun Apr 19 2015 marcin82 <fixxer1982@gmail.com> 8.039.00-1pclos2015
- built for PCLinuxOS
